/*-
 * ~~~~~~licensing~~~~~~
 * profile-management
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.base.management.core.utils;

import org.osgi.framework.Bundle;

public class BundleAwareManagedObjectImpl implements BundleAwareManagedObject {

	protected String bundleState;
	
	protected long bundleId;
	
	protected String bundleSymbolicName;

	@Override
	public String getBundleState() {
		return bundleState;
	}

	@Override
	public void setBundleState(String bundleState) {
		this.bundleState = bundleState;
	}

	@Override
	public long getBundleId() {
		return bundleId;
	}

	@Override
	public void setBundleId(long bundleId) {
		this.bundleId = bundleId;
	}

	@Override
	public String getBundleSymbolicName() {
		return bundleSymbolicName;
	}

	@Override
	public void setBundleSymbolicName(String bundleSymbolicName) {
		this.bundleSymbolicName = bundleSymbolicName;
	}
	
	@Override
	public BundleAwareManagedObject bundleState(String bundleState) {
		setBundleState(bundleState);
		return this;
	}

	@Override
	public BundleAwareManagedObject bundleState(int bundleState) {
		String bs = "UNKNOWN";
		switch (bundleState) {
		case Bundle.ACTIVE:
			bs = "Active";
			break;
		case Bundle.INSTALLED:
			bs = "Installed";
			break;
		case Bundle.RESOLVED:
			bs = "Resolved";
			break;
		case Bundle.STARTING:
			bs = "Starting";
			break;
		case Bundle.STOPPING:
			bs = "Stopping";
			break;
		case Bundle.UNINSTALLED:
			bs = "Uninstalled";
			break;
		}
		return this.bundleState(bs);
	}
	
	@Override
	public BundleAwareManagedObject bundleId(long bundleId) {
		setBundleId(bundleId);
		return this;
	}
	
	@Override
	public BundleAwareManagedObject bundleSymbolicName(String bundleSymbolicName) {
		setBundleSymbolicName(bundleSymbolicName);
		return this;
	}
	
}
